
/* Extends jQuery */
(function($){
	$.sp = $.sp || {};
	
	/* extend ajax request methods */
    var _ajax = $.ajax;
    $.ajax = function(s) {
        var _success = s.success;
        var _error = s.error;
        var _complete = s.complete;
        s.success = function(data, status, xhr){
        	plus.nativeUI.closeWaiting();
        	var dataObject = data;
        	if(typeof dataObject != 'object') 
        	{       		
        		try {dataObject = JSON.parse(dataObject);
        	      } 
        	catch (e) {
        		dataObject = dataObject.substring(dataObject.indexOf("message")-2,dataObject.indexOf("success")+15);
        		try {
        			dataObject = JSON.parse(dataObject);
        			if(dataObject && dataObject.err) {
				          plus.nativeUI.toast( dataObject.message,{verticalAlign:'center'}); 
				          return;
        	        }
        		}
        		catch(e1)
        		{
        			plus.nativeUI.toast( "出错了。",{verticalAlign:'center'});
        			return;
        		}
        	}
        	}

        	if(dataObject && dataObject.err) {
        			plus.nativeUI.toast( dataObject.message,{verticalAlign:'center'});
				
        	}
        	else _success(data, status, xhr);
        };

        	s.error = function(XMLHttpRequest, textStatus, errorThrown){
        	    plus.nativeUI.closeWaiting();
        	    plus.nativeUI.toast( "连接服务器出错了。",{verticalAlign:'center'});
             }

        	s.complete = function(xhr, ts){
        	    _complete(xhr, ts);
             }
        
        return _ajax(s);
    };

    $.sp.getAjaxConf = function(url, jsonData, success,funcs) {
		return {
            url: url,
            type: "POST",
            data: jsonData ? JSON.stringify(jsonData) : null,
            //dataType: "json",
            contentType: "application/json; charset=utf-8",
            success: success,
            error:function(){},
            complete:function(){}
        };
	};
	$.get = function (url,success,options) {
		var obj = {
			url: url,
            type: "GET",
            success: success,
            error:function(){},
            complete:function(){}
		}
        $.ajax($.extend(options, obj));
    };
	$.postJSON = function (url, jsonData, success,options) {
        $.ajax($.extend(options, $.sp.getAjaxConf(url, jsonData, success)));
    };
	$.putJSON = function (url, jsonData, success, options) {
        $.ajax($.extend(options, $.sp.getAjaxConf(url, jsonData, success), {type:'PUT'}));
    };
	$.deleteJSON = function (url, jsonData, success, options) {
        $.ajax($.extend(options, $.sp.getAjaxConf(url, jsonData, success), {type:'DELETE'}));
    };
	
    /* extend jquery element methods */
	$.sp.toNum = function($el, prop) {
		return parseInt($el.css(prop))||0;
	};
	$.fn.widthEx = function(){
		var $el = $(this), ew = 0; 
		for (var i = 0, props = ['marginLeft', 'borderLeftWidth', 'paddingLeft', 'paddingRight', 'borderRightWidth', 'marginRight']; i < props.length; i++)
			ew += $.sp.toNum($el, props[i]);
		return ew;
	};
	$.fn.heightEx = function(){
		var $el = $(this), eh = 0; 
		for (var i = 0, props = ['marginTop', 'borderTopWidth', 'paddingTop', 'paddingBottom', 'borderBottomWidth', 'marginBottom']; i < props.length; i++)
			eh += $.sp.toNum($el, props[i]);
		return eh;
	};	
})(jQuery);

